3 ## "dotest" is my stupid name for my patch-application script, which
4 ## I never got around to renaming after I tested it. We're now on the
5 ## second generation of scripts, still called "dotest".
7 ## Update: Ryan Anderson finally shamed me into naming this "applymbox".
9 ## You give it a mbox-format collection of emails, and it will try to
10 ## apply them to the kernel using "applypatch"
12 ## applymbox [-u] [-k] [-q] (-c .dotest/msg-number | mail_archive) [Signoff_file]"
14 ## The patch application may fail in the middle. In which case:
15 ## (1) look at .dotest/patch and fix it up to apply
16 ## (2) re-run applymbox with -c .dotest/msg-number for the current one.
17 ## Pay a special attention to the commit log message if you do this and
18 ## use a Signoff_file, because applypatch wants to append the sign-off
19 ## message to msg-clean every time it is run.
21 . git-sh-setup || die "Not a git archive"
24 echo >&2 "applymbox [-u] [-k] [-q] (-c .dotest/<num> | mbox) [signoff]"
28 keep_subject= query_apply= continue= utf8= resume=t
29 while case "$#" in 0) break ;; esac
33 -k) keep_subject=-k ;;
35 -c) continue="$2"; resume=f; shift ;;
46 git-mailsplit "$1" .dotest || exit 1
50 files=$(git-diff-index --cached --name-only HEAD) || exit
52 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
56 case "$query_apply" in
57 t) touch .dotest/.query_apply
59 case "$keep_subject" in
60 -k) : >.dotest/.keep_subject
66 while case "$#" in 0) break;; esac
69 case "$resume,$continue" in
74 git-mailinfo $keep_subject $utf8 \
75 .dotest/msg .dotest/patch <$i >.dotest/info || exit 1
76 git-stripspace < .dotest/msg > .dotest/msg-clean
79 while :; # for fixing up and retry
81 git-applypatch .dotest/msg-clean .dotest/patch .dotest/info "$signoff"
84 # 2 is a special exit code from applypatch to indicate that
85 # the patch wasn't applied, but continue anyway
89 if test -f .dotest/.query_apply
91 echo >&2 "* Patch failed."
92 echo >&2 "* You could fix it up in your editor and"
93 echo >&2 " retry. If you want to do so, say yes here"
94 echo >&2 " AFTER fixing .dotest/patch up."
95 echo >&2 -n "Retry [y/N]? "